var	oPrefs	= Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

//DataSource
var gXyzProxyRdfService	= null;
var gXyzProxyDataSource	= null;
var gXyzProxyRdfContainer	= null;
var gXyzProxyRdfUtil		= null;
var gXyzProxyDir			= null;

var gXyzProxyPAC			=false;//是否使用pac

var gXyzDataSrcFile			= null;//"chrome://xyzproxy/content/xyzproxy.rdf"; //"chrome://xyzproxy/content/test.rdf";//"rdf:localstore";
const gRdfProxyRoot			= "http://xyzboard.com/firefox/xyzproxy/rdf/all";
const gRdfProxyPropRoot		= "http://xyzboard.com/firefox/xyzproxy/rdf";


var gXyzProxyStrBundle;

function InitDataSource()
{
	if(gXyzDataSrcFile==null)
		gXyzDataSrcFile=xyzProxyGetDir();

	if(gXyzProxyRdfService==null)
		gXyzProxyRdfService		= Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	if(gXyzProxyDataSource==null)
		gXyzProxyDataSource		= gXyzProxyRdfService.GetDataSourceBlocking(gXyzDataSrcFile);
	if(gXyzProxyRdfContainer==null)
		gXyzProxyRdfContainer	= Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
	if(gXyzProxyRdfUtil==null)
		gXyzProxyRdfUtil		= Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);

	//Get or Add Sequence
	try{
		gXyzProxyRdfContainer.Init(gSProxyDataSource, gXyzProxyRdfServiceService.GetResource(gRdfProxyRoot)); //Get
	}catch(err){
		gXyzProxyRdfContainer = gXyzProxyRdfUtil.MakeSeq(gXyzProxyDataSource, gXyzProxyRdfService.GetResource(gRdfProxyRoot)); //Create
	}
}

function GetAllProxiesElement()
{
	var aProxies		= new Array();
	var aElements		= gXyzProxyRdfContainer.GetElements();
	while(aElements.hasMoreElements()){
		var oRes = aElements.getNext();
		oRes = oRes.QueryInterface(Components.interfaces.nsIRDFResource);
		aProxies[aProxies.length] = oRes.Value;
	}
	return aProxies;
}


//@todo变成可复用的
function InitLoadProxyList(){
	InitDataSource();
	xyzProxyEmptyProxyUIList();

	var aProxies		= GetAllProxiesElement();

	for(i = 0; i < aProxies.length; i++){
	
		if(typeof(aProxies[i]) == 'undefined')
			continue; 
		
		try{
			var proxyName=null;
			var proxyHTTP=null;
			var proxyHTTP_PORT=null;
			var aTarget=null;
			var aPropRes=null;
		
			var aProxiesRes	= gXyzProxyRdfService.GetResource(aProxies[i]);
			aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP");
			aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
			if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
						proxyHTTP=aTarget.Value;
			}
			aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#name");
			aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
			if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
						proxyName=aTarget.Value;
			}
			aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP_Port");
			aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
			if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
						proxyHTTP_PORT=aTarget.Value;
			}
			AppendToProxyListUI(proxyName, aProxies[i],proxyHTTP, proxyHTTP_PORT, false, 0);
		} catch(err) {}
	}
	UpdateMenuListCheckedUI();
}



function enableproxy()
{
	var isproxyon= oPrefs.getIntPref("network.proxy.type");
	if(isproxyon==0){
		if(gXyzProxyPAC){
			isproxyon=2;
		}
		else{
			isproxyon=1;
		}
	}else{
		isproxyon=0;
	}
	oPrefs.setIntPref("network.proxy.type", isproxyon);
	UpdateButtonUI();
}


function UpdateButtonUI()
{
	var isproxyon= oPrefs.getIntPref("network.proxy.type");
	var container = document.getElementById("xyzproxy-Toolbar-button");
	if(isproxyon==0){
		//不使用代理
		container.setAttribute("pbbstatus", "off");
	}else{
		//使用代理
		container.setAttribute("pbbstatus", "on");
	}
}

function UpdateMenuListCheckedUI()
{
	var curProxyHTTP		= oPrefs.getCharPref("network.proxy.http");
	var curproxyHTTP_PORT	= oPrefs.getIntPref("network.proxy.http_port");

	//toolbar
	var container = document.getElementById("xyzproxy-Toolbar-button");
	var currentProxy= curProxyHTTP+':'+curproxyHTTP_PORT;
	container.setAttribute("tooltiptext",currentProxy);

	//statusbar
	var isproxyon= oPrefs.getIntPref("network.proxy.type");
	container = document.getElementById("xyzproxy-status");
	if(isproxyon==1){
		container.setAttribute("label",'proxy');
		gXyzProxyPAC = false;
	}
	else if(isproxyon==2){
		container.setAttribute("label",'PAC');
		gXyzProxyPAC = true;
	}
	else{
		container.setAttribute("label",'');
	}

	var elemlist=document.getElementById('toolbutton-popup-list');
	if(elemlist!=null){

		//Uncheck Other//@todo 得修改这段代码 ,会伤及无gu//好像已经改好了by xw 2006-02-27
		var aChecked = elemlist.getElementsByAttribute("class", "proxy-menu-item");
		for(var c = 0; c < aChecked.length; c++){
			aChecked[c].setAttribute("checked", false);
			//如果使用gXyzProxyPAC，则全部disable
			aChecked[c].setAttribute("disabled", gXyzProxyPAC);
		}

		//check status
		var isHidden=true;
		if(oPrefs.prefHasUserValue("xyzproxy.display.statusbar")){
			isHidden= oPrefs.getBoolPref("xyzproxy.display.statusbar")
			gXyzProxyPAC= oPrefs.getBoolPref("xyzproxy.display.pac")
		}
		else{
			oPrefs.setBoolPref("xyzproxy.display.statusbar",isHidden );
			oPrefs.setBoolPref("xyzproxy.display.pac",gXyzProxyPAC );
		}

		document.getElementById("menuitem-showstatus").setAttribute("checked", !isHidden);
		document.getElementById("menuitem-usepac").setAttribute("checked", gXyzProxyPAC);

		//找到需要check的
		aChecked = elemlist.getElementsByAttribute("valuehttp", currentProxy);
		for(c = 0; c < aChecked.length; c++){
			aChecked[c].setAttribute("checked", true);
			if(isproxyon==1){
				container.setAttribute("label",xyzProxyGetString("common.proxy")+':'+aChecked[c].getAttribute("label"));
			}
			else if(isproxyon==2){
				container.setAttribute("label",'PAC');
			}
			else{
				container.setAttribute("label",'');
			}
		}
	}
}

//Add Item to lists
function AppendToProxyListUI(sLabel, sValue,valuehttp, valuehttpport, isSelected, iType)
{

	var oItem = null;
	xyzMenuList=document.getElementById("toolbutton-popup-list");

	if(xyzMenuList==null){
		return;
	}

	if(sLabel==null){
		sLabel=valuehttp+':'+valuehttpport;
	}

	//Get separator, which is after proxy list
	var oSeparator = document.getElementById("xyzhproxy-menu-list-separator");
	oItem = document.createElement("menuitem");
	oItem.setAttribute("id", sValue);
	oItem.setAttribute("label", sLabel);
	oItem.setAttribute("valuehttp", valuehttp+':'+valuehttpport);
	oItem.setAttribute("valuehttpport", valuehttpport);
	oItem.setAttribute("tooltiptext", valuehttp+':'+valuehttpport);
	oItem.setAttribute("type", "checkbox");
	oItem.setAttribute("checked", isSelected);
	oItem.setAttribute("proxyType", iType);	
	oItem.setAttribute("class", "proxy-menu-item");
	oItem.setAttribute("oncommand", " selectproxy(this);  event.preventBubble();");
	xyzMenuList.appendChild(oItem);

	if(isSelected){
		switchproxy_selectItem(sLabel);
	}

}


function selectproxy(oMenuItem)
{

	InitDataSource();
	var elemlist=document.getElementById('toolbutton-popup-list');
	
	//设置proxy
	var aProxy=oMenuItem.id;

	var proxyHTTP=null;
	var proxyHTTP_PORT=null;
	var aTarget=null;
	var aPropRes=null;

	var aProxiesRes	= gXyzProxyRdfService.GetResource(aProxy);
	aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP");
	aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
	if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
				proxyHTTP=aTarget.Value;
	}
	aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP_Port");
	aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
	if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
				proxyHTTP_PORT=aTarget.Value;
	}

	oPrefs.setCharPref("network.proxy.http",proxyHTTP);
	oPrefs.setIntPref("network.proxy.http_port",parseInt(proxyHTTP_PORT));
	oPrefs.setCharPref("network.proxy.http",proxyHTTP);
	oPrefs.setIntPref("network.proxy.http_port",parseInt(proxyHTTP_PORT));
	oPrefs.setCharPref("network.proxy.ssl",proxyHTTP);
	oPrefs.setIntPref("network.proxy.ssl_port",parseInt(proxyHTTP_PORT));
	oPrefs.setCharPref("network.proxy.ftp",proxyHTTP);
	oPrefs.setIntPref("network.proxy.ftp_port",parseInt(proxyHTTP_PORT));
	oPrefs.setCharPref("network.proxy.gopher",proxyHTTP);
	oPrefs.setIntPref("network.proxy.gopher_port",parseInt(proxyHTTP_PORT));
	oPrefs.setCharPref("network.proxy.socks",proxyHTTP);
	oPrefs.setIntPref("network.proxy.socks_port",parseInt(proxyHTTP_PORT));

	if(!gXyzProxyPAC){
		oPrefs.setIntPref("network.proxy.type", 1);
	}

	oMenuItem.setAttribute("checked", true);	

	//下面的东东会自动调用, 所以去掉了

//	UpdateMenuListCheckedUI();
//	if(elemlist!=null){
//		//Uncheck Other
//		var aChecked = elemlist.getElementsByAttribute("checked", "true");
//		for(var c = 0; c < aChecked.length; c++){
//			aChecked[c].setAttribute("checked", false);
//		}
//		oMenuItem.setAttribute("checked", true);	
//	}

}


function xyzProxyImportProxy()
{
	InitDataSource();

	//Open Dialog
	var fileDir;
	var nsIFilePicker	= Components.interfaces.nsIFilePicker;
	var oPicker			= Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		oPicker.init(window, "Select a File", nsIFilePicker.modeOpen);
		oPicker.appendFilter("Text Files","*.txt");
		oPicker.appendFilter("All Files","*.*");
	var oRes			= oPicker.show();
	
	//Get Filepath
	if(oRes == nsIFilePicker.returnOK ){
		fileDir = oPicker.file.path;
	}
	else{
		return;
	}

	//Get proxy list
	var oFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	  oFile.initWithPath(fileDir);
	var oFileStream   = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
	  oFileStream.init(oFile, 0x01, 00440, null);
	var oScriptStream   = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	  oScriptStream.init(oFileStream);
	
	var sProxyList = oScriptStream.read(oScriptStream.available());

	//Split Proxy List
	aProxies = sProxyList.split("\n");

	for(var i=0;i<aProxies.length;i++){
		aProxies[i]=xyzProxytrim(aProxies[i]);
		if(aProxies[i].length<=1){
			continue;//去除空行
		}
		var aProxy=xyzProxySplitDomain(aProxies[i]);
		var aUri=xyzProxyGetUniqueProxyUri();

		//放入rdf
		var tmpProxyRes=gXyzProxyRdfService.GetResource(aUri);
		gXyzProxyRdfContainer.AppendElement(tmpProxyRes);
		var oProp;
		oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot + "#networkProxyHTTP");
		xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[0],true);
		oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP_Port");
		xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[1],true);

		if(aProxy[2]!=null){
			oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#name");
			xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[2],true);
		}

		AppendToProxyListUI( aProxy[2], aUri, aProxy[0], aProxy[1], false,0);
	}

	UpdateMenuListCheckedUI();
}

//Get String Bundle
function xyzProxyGetString(sKey){
	try{
	
		if(gXyzProxyStrBundle == null){
			var oBundle			= Components.classes['@mozilla.org/intl/stringbundle;1'].getService(Components.interfaces.nsIStringBundleService);
			gXyzProxyStrBundle	= oBundle.createBundle('chrome://xyzproxy/locale/xyzproxy.properties');
		}
		
		return gXyzProxyStrBundle.GetStringFromName(sKey);
			
	}catch(err){}
	
	return sKey;
}


function xyzProxyEmptyProxyRDF()
{
	//清空RDF
	InitDataSource();
	var aProxies		= GetAllProxiesElement();
	for(i = 0; i < aProxies.length; i++){
		xyzProxyRemoveElement(aProxies[i]);
	}
}

//@todo rename
var emptyNum=0;
function xyzProxyEmptyProxyUIList()
{

	emptyNum++;

	//清空菜单
	var elemlist=document.getElementById('toolbutton-popup-list');
	if(elemlist!=null){
		var aProxyListElem = elemlist.getElementsByAttribute("class", "proxy-menu-item");
		for(var c = 0; c < aProxyListElem.length; c++){
			elemlist.removeChild(aProxyListElem[c]);
		}
	}
	//again for 1.6beta1
	if(elemlist!=null){
		var aProxyListElem = elemlist.getElementsByAttribute("class", "proxy-menu-item");
		if(aProxyListElem.length!=0  && emptyNum<10){
			xyzProxyEmptyProxyUIList();
		}
		else{
			emptyNum=0;
		}
	}
}

function xyzProxyEmptyProxy()
{
	if(confirm(xyzProxyGetString("common.confirm.clearproxy"))){
		//清空RDF
		xyzProxyEmptyProxyRDF();
		//清空菜单
		xyzProxyEmptyProxyUIList();
	}
}

//Remove Element for sUri
function xyzProxyRemoveElement(sUri){

	try{
		var oRes = gXyzProxyRdfService.GetResource(sUri);
	
		//Remove All Archs
		// Loop for duplicates
		var aArchs		= null;
		var hasArchs	= true;
		while(hasArchs){
			aArchs		 = gXyzProxyDataSource.ArcLabelsOut(oRes);
			hasArchs	 = aArchs.hasMoreElements();
			while(aArchs.hasMoreElements()){
				oArch = aArchs.getNext().QueryInterface(Components.interfaces.nsIRDFResource);				
				//Remove Props
				gXyzProxyDataSource.Unassert(oRes, oArch, gXyzProxyDataSource.GetTarget(oRes, oArch, true));
			}
		}		
		//Remove Element
		gXyzProxyRdfContainer.RemoveElement(oRes, true);

	}catch(err){throw "(xyzProxyRemoveElement)\n" + err}
}

//Add Property oProp to oRes
function xyzProxyAddProperty(oRes, oProp, sValue, overwriteExisting){
	try{
		//Don't overwrite it this property exists
		if(!overwriteExisting && gXyzProxyDataSource.hasArcOut(oRes, oProp))
			return;
			
		//Add
		gXyzProxyDataSource.Assert(oRes, oProp, gXyzProxyRdfService.GetLiteral(sValue), true);
	}catch(err){throw "(xyzAddProperty)\n" + err}
}

//Generates random number for proxy URI
function xyzProxyGetUniqueProxyUri(){
	var sUri = gRdfProxyRoot + "/sp_proxy_" + Math.round((Math.random() * 200000));
	
	if(xyzProxyDoesProxyElementExist(sUri))
		return xyzProxyGetUniqueProxyUri();
	
	return sUri;
}

//Does URI Exist
function xyzProxyDoesProxyElementExist(sProxyUri){
	var aElems		= GetAllProxiesElement();
	for(var e = 0; e < aElems.length; e++){
		if(aElems[e] == sProxyUri)
			return true;
	}		
}


function xzyProxyConvertFilePathToURL(aFilePath)
{
	var tmpFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	var tmpIO	= Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
	tmpFile.initWithPath(aFilePath);
	return tmpIO.newFileURI(tmpFile).spec;
}


function xyzProxyGetDir(){
	gXyzProxyDir		=Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);

	var	myDataDir		= gXyzProxyDir.get("ProfD", Components.interfaces.nsIFile);
	var myDataDirUrl	= xzyProxyConvertFilePathToURL(myDataDir.path);
	if ( myDataDirUrl.charAt(myDataDirUrl.length - 1) != "/" ){
		myDataDirUrl = myDataDirUrl + "/";
	}
	myDataDirUrl+="xyzproxy.rdf";
	return myDataDirUrl;
}

// Splits a domain or IP from it's port number
//	returns array[1]
//		array[0] = (String) Domain or IP
//		array[1] = (String) Port Number	
function xyzProxySplitDomain(sDomain){
	var aOut	 = new Array();
	var iPort	= -1;
	
	if( (iPort = sDomain.indexOf(":")) > -1){
		aOut[0] = sDomain.substring(0, iPort);
		aOut[1] = sDomain.substring(iPort + 1);
	}
	else{
		aOut[0] = sDomain;
		aOut[1] = "80";
 	}

	//提取注释
	aOut[2]=null;
	if( (iPort = aOut[1].indexOf("#")) > -1){
		aOut[2] = aOut[1].substring(iPort + 1);
		aOut[1] = aOut[1].substring(0, iPort);
	}

	return aOut;
}

// Trims space from both sides of str
function xyzProxytrim(str){
	str	= str.replace(new RegExp("^[\\s\\n\\r]*", "g"), "");
	str	= str.replace(new RegExp("[\\s\\n\\r]*$", "g"), "");
	
	return str;
}

function xyzproxyInit()
{
	window.removeEventListener("load", xyzproxyInit, true);
	var rObserver = {
            observe : function(subject, topic, data) { UpdateButtonUI(); UpdateMenuListCheckedUI();}
     };
	var prefService = Components.classes["@mozilla.org/preferences-service;1"].	getService(Components.interfaces.nsIPrefService);
	var rBranch = prefService.getBranch("network.");
	var pbi = rBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
	pbi.addObserver("proxy", rObserver, false);

	var isHidden=true;
	if(oPrefs.prefHasUserValue("xyzproxy.display.statusbar")){
		isHidden= oPrefs.getBoolPref("xyzproxy.display.statusbar");
	}
	else{
		oPrefs.setBoolPref("xyzproxy.display.statusbar",isHidden );
	}
	document.getElementById("xyzproxy-status").setAttribute("collapsed", isHidden);
	//document.getElementById("menuitem-showstatus").setAttribute("checked", !isHidden);

	if(oPrefs.prefHasUserValue("xyzproxy.display.pac")){
		gXyzProxyPAC= oPrefs.getBoolPref("xyzproxy.display.pac");
	}
	else{
		oPrefs.setBoolPref("xyzproxy.display.pac",gXyzProxyPAC );
	}
	//document.getElementById("menuitem-usepac").setAttribute("checked", gXyzProxyPAC);

	//load rdf
	//upadte UI

	//设置network.proxy.type
	var isproxyon= oPrefs.getIntPref("network.proxy.type");
	if(isproxyon!=0){
		if(gXyzProxyPAC){
			oPrefs.setIntPref("network.proxy.type", 2);
		}
		else{
			oPrefs.setIntPref("network.proxy.type", 1);
		}
	}

	InitLoadProxyList();
	UpdateButtonUI();
	UpdateMenuListCheckedUI();
	
}


function xyzProxyEditProxyInit()
{
//读出sProxyList
	InitDataSource();
	var gStrProxyList='';

	var aProxiesElement		= GetAllProxiesElement();

	for(i = 0; i < aProxiesElement.length; i++){
	
		if(typeof(aProxiesElement[i]) == 'undefined')
			continue; 
		
		var proxyName=null;
		var proxyHTTP=null;
		var proxyHTTP_PORT=null;
		var aTarget=null;
		var aPropRes=null;
	
		var aProxiesRes	= gXyzProxyRdfService.GetResource(aProxiesElement[i]);
		aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP");
		aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
		if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
					proxyHTTP=aTarget.Value;
		}
		aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP_Port");
		aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
		if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
					proxyHTTP_PORT=aTarget.Value;
		}

		gStrProxyList+=proxyHTTP+':'+proxyHTTP_PORT;

		aPropRes		= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#name");
		aTarget			= gXyzProxyDataSource.GetTarget(aProxiesRes,aPropRes,true);
		if(aTarget instanceof Components.interfaces.nsIRDFLiteral){
					proxyName=aTarget.Value;
					//可选
					gStrProxyList+='#'+proxyName;
		}
		gStrProxyList+='\n';

	}
      allProxyList = document.getElementById("allproxies");
	  allProxyList.value=gStrProxyList;
}

function xyzProxyEditProxy()
{
	window.openDialog("chrome://xyzproxy/content/editproxy.xul","editproxy","centerscreen, chrome ");

}


function xyzProxyEditProxyDone()
{
	var gStrProxyList=allProxyList.value;
	if(gStrProxyList.length==0){
		return ;
	}

//清空rdf文件
	xyzProxyEmptyProxyRDF();

//导入sProxyList
	//Split Proxy List
	aProxies = gStrProxyList.split("\n");

	for(i=0 ; i<aProxies.length ; i++){
		aProxies[i]=xyzProxytrim(aProxies[i]);
		if(aProxies[i].length<=1){
			continue;//去除空行
		}
		var aProxy=xyzProxySplitDomain(aProxies[i]);
		var aUri=xyzProxyGetUniqueProxyUri();

		//放入rdf
		var tmpProxyRes=gXyzProxyRdfService.GetResource(aUri);
		gXyzProxyRdfContainer.AppendElement(tmpProxyRes);
		var oProp;
		oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot + "#networkProxyHTTP");
		xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[0],true);
		oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#networkProxyHTTP_Port");
		xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[1],true);

		if(aProxy[2]!=null){
		oProp= gXyzProxyRdfService.GetResource(gRdfProxyPropRoot+"#name");
		xyzProxyAddProperty(tmpProxyRes,oProp,aProxy[2],true);
		}

		AppendToProxyListUI( aProxy[2], aUri, aProxy[0], aProxy[1], false,0);
	}
}

function xyzProxyShowStatus(){
	var isHidden=true;
	if(oPrefs.prefHasUserValue("xyzproxy.display.statusbar")){
		isHidden= !oPrefs.getBoolPref("xyzproxy.display.statusbar")
	}

	oPrefs.setBoolPref("xyzproxy.display.statusbar",isHidden );
	document.getElementById("xyzproxy-status").setAttribute("collapsed", isHidden);
	document.getElementById("menuitem-showstatus").setAttribute("checked", !isHidden);
}

function xyzProxyUsePac(){
	//使用PAC，而不是代理
	if(oPrefs.prefHasUserValue("xyzproxy.display.pac")){
		gXyzProxyPAC= !oPrefs.getBoolPref("xyzproxy.display.pac")
	}
	oPrefs.setBoolPref("xyzproxy.display.pac",gXyzProxyPAC );
	
	//设置好pac
	if(gXyzProxyPAC){
		oPrefs.setIntPref("network.proxy.type", 2);
	}
	else{
		oPrefs.setIntPref("network.proxy.type", 0);
	}
	//强制调用 update ui
	UpdateMenuListCheckedUI();
}


// 测试用
function onShowMenu(event){
}

